import { GluegunParameters } from '../domain/toolbox';
import { Options } from '../domain/options';
/**
 * Parses given command arguments into a more useful format.
 *
 * @param commandArray Command string or list of command parts.
 * @param extraOpts Extra options.
 * @returns Normalized parameters.
 */
export declare function parseParams(commandArray: string | string[], extraOpts?: Options): GluegunParameters;
/**
 * Constructs the parameters object.
 *
 * @param params Provided parameters
 * @return An object with normalized parameters
 */
export declare function createParams(params: any): GluegunParameters;
